<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::entropy_encoder_kernel_2 Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1entropy__encoder__kernel__2.html">entropy_encoder_kernel_2</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdlib_1_1entropy__encoder__kernel__2-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::entropy_encoder_kernel_2 Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:afb1dc81514150872425c3a0eb26de4dd"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1entropy__encoder__kernel__2.html#afb1dc81514150872425c3a0eb26de4dd">entropy_encoder_kernel_2</a> ()</td></tr>
<tr class="separator:afb1dc81514150872425c3a0eb26de4dd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4feecdfd286f3b16f39dbdf9f9fbc221"><td class="memItemLeft" align="right" valign="top"><a id="a4feecdfd286f3b16f39dbdf9f9fbc221"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>clear</b> ()</td></tr>
<tr class="separator:a4feecdfd286f3b16f39dbdf9f9fbc221"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:addc7354f1cd1954679d8842199b749fc"><td class="memItemLeft" align="right" valign="top"><a id="addc7354f1cd1954679d8842199b749fc"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>set_stream</b> (std::ostream &amp;out)</td></tr>
<tr class="separator:addc7354f1cd1954679d8842199b749fc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a66c9385f7895776cf7eb7e2933f5d69d"><td class="memItemLeft" align="right" valign="top"><a id="a66c9385f7895776cf7eb7e2933f5d69d"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>stream_is_set</b> () const</td></tr>
<tr class="separator:a66c9385f7895776cf7eb7e2933f5d69d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8be5cb0231f7dcf8e90ef27c54403fea"><td class="memItemLeft" align="right" valign="top"><a id="a8be5cb0231f7dcf8e90ef27c54403fea"></a>
std::ostream &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>get_stream</b> () const</td></tr>
<tr class="separator:a8be5cb0231f7dcf8e90ef27c54403fea"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaf1d6d048fb9cc9a66f08ceb94412201"><td class="memItemLeft" align="right" valign="top"><a id="aaf1d6d048fb9cc9a66f08ceb94412201"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>encode</b> (uint32 low_count, uint32 high_count, uint32 total)</td></tr>
<tr class="separator:aaf1d6d048fb9cc9a66f08ceb94412201"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:a0ffa97525942a88a09cf96f2924f4cd0"><td class="memItemLeft" align="right" valign="top"><a id="a0ffa97525942a88a09cf96f2924f4cd0"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>flush</b> ()</td></tr>
<tr class="separator:a0ffa97525942a88a09cf96f2924f4cd0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a779617ae7059a305fcf004e7eec09dfc"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1entropy__encoder__kernel__2.html#a779617ae7059a305fcf004e7eec09dfc">entropy_encoder_kernel_2</a> (<a class="el" href="classdlib_1_1entropy__encoder__kernel__2.html">entropy_encoder_kernel_2</a> &amp;)</td></tr>
<tr class="separator:a779617ae7059a305fcf004e7eec09dfc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a43f3b8bf16eb31512f2e70a98ab7b5d3"><td class="memItemLeft" align="right" valign="top"><a id="a43f3b8bf16eb31512f2e70a98ab7b5d3"></a>
<a class="el" href="classdlib_1_1entropy__encoder__kernel__2.html">entropy_encoder_kernel_2</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (<a class="el" href="classdlib_1_1entropy__encoder__kernel__2.html">entropy_encoder_kernel_2</a> &amp;)</td></tr>
<tr class="separator:a43f3b8bf16eb31512f2e70a98ab7b5d3"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a741ca6324588ab78b28684224ead117d"><td class="memItemLeft" align="right" valign="top"><a id="a741ca6324588ab78b28684224ead117d"></a>
const uint32&#160;</td><td class="memItemRight" valign="bottom"><b>initial_low</b></td></tr>
<tr class="separator:a741ca6324588ab78b28684224ead117d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9b30a935ef2db56c21db0899a6ccf62c"><td class="memItemLeft" align="right" valign="top"><a id="a9b30a935ef2db56c21db0899a6ccf62c"></a>
const uint32&#160;</td><td class="memItemRight" valign="bottom"><b>initial_high</b></td></tr>
<tr class="separator:a9b30a935ef2db56c21db0899a6ccf62c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6da09b1991c387c69e2741c9f1f11466"><td class="memItemLeft" align="right" valign="top"><a id="a6da09b1991c387c69e2741c9f1f11466"></a>
std::ostream *&#160;</td><td class="memItemRight" valign="bottom"><b>out</b></td></tr>
<tr class="separator:a6da09b1991c387c69e2741c9f1f11466"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2753d1351688aa385bfa429e455ad8f0"><td class="memItemLeft" align="right" valign="top"><a id="a2753d1351688aa385bfa429e455ad8f0"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><b>low</b></td></tr>
<tr class="separator:a2753d1351688aa385bfa429e455ad8f0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7ec0aef9b3241148e714e4673ef24e2b"><td class="memItemLeft" align="right" valign="top"><a id="a7ec0aef9b3241148e714e4673ef24e2b"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><b>high</b></td></tr>
<tr class="separator:a7ec0aef9b3241148e714e4673ef24e2b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2279db725f47c961051ffcfcaf359511"><td class="memItemLeft" align="right" valign="top"><a id="a2279db725f47c961051ffcfcaf359511"></a>
std::streambuf *&#160;</td><td class="memItemRight" valign="bottom"><b>streambuf</b></td></tr>
<tr class="separator:a2279db725f47c961051ffcfcaf359511"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="afb1dc81514150872425c3a0eb26de4dd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afb1dc81514150872425c3a0eb26de4dd">&#9670;&nbsp;</a></span>entropy_encoder_kernel_2() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">dlib::entropy_encoder_kernel_2::entropy_encoder_kernel_2 </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>GENERAL NOTES this encoder is implemented using "range" coding</p>
<p>INITIAL VALUE out == 0 initial_low == 0x00000001 (slightly more than zero) initial_high == 0xffffffff (slightly less than one, 0.99999999976717) low == initial_low high == initial_high</p>
<p>CONVENTION if (out != 0) out == get_stream() true == stream_is_set() streambuf == out-&gt;rdbuf() else false == stream_is_set()</p>
<pre class="fragment">   low      == the low end of the range used for arithmetic encoding.
               this number is used as a 32bit fixed point real number. 
               the point is fixed just before the first bit, so it is
               always in the range [0,1)

               low is also never allowed to be zero to avoid overflow
               in the calculation (high-low+1)/total.

   high     == the high end of the range - 1 used for arithmetic encoding.
               this number is used as a 32bit fixed point real number. 
               the point is fixed just before the first bit, so when we
               interpret high as a real number then it is always in the
               range [0,1)

               the range for arithmetic encoding is always 
               [low,high + 0.9999999...)   the 0.9999999... is why
               high == real upper range - 1         
</pre><p> ! </p>

</div>
</div>
<a id="a779617ae7059a305fcf004e7eec09dfc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a779617ae7059a305fcf004e7eec09dfc">&#9670;&nbsp;</a></span>entropy_encoder_kernel_2() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">dlib::entropy_encoder_kernel_2::entropy_encoder_kernel_2 </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classdlib_1_1entropy__encoder__kernel__2.html">entropy_encoder_kernel_2</a> &amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    out != 0 (i.e.  there is a stream object to flush the data to 
</pre><p> ! </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="entropy__encoder__kernel__2_8h_source.html">entropy_encoder_kernel_2.h</a></li>
<li>entropy_encoder_kernel_2.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
